]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
pid output of /etc/init.d/teamspeak status
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.1" # Version number
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36IPFVER="full" # Which versions should be compiled? (full|devel)
37
38# Debian specific settings
39if [ ! -e /etc/debian_version ]; then
40 FULLPATH=`which $0`
41else
42 if [ -x /usr/bin/realpath ]; then
43 FULLPATH=`/usr/bin/realpath $0`
44 else
45 echo "ERROR: Need to do apt-get install realpath"
46 exit 1
47 fi
48fi
49
50PWD=`pwd`
51BASENAME=`basename $0`
52BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
53LOGFILE=$BASEDIR/log/_build.preparation.log
54export BASEDIR LOGFILE
55DIR_CHK=$BASEDIR/cache/check
56mkdir $BASEDIR/log/ 2>/dev/null
57
58# Include funtions
59. tools/make-functions
60
61if [ -f .config ]; then
62 . .config
63else
64 echo -e "${BOLD}No configuration found!${NORMAL}"
65 echo -ne "Do you want to create one (y/N)?"
66 read CREATE_CONFIG
67 echo ""
68 if [ "$CREATE_CONFIG" == "y" ]; then
69 make_config
70 fi
71fi
72
73prepareenv() {
74 ############################################################################
75 # #
76 # Are we running the right shell? #
77 # #
78 ############################################################################
79 if [ ! "$BASH" ]; then
80 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
81 fi
82
83 if [ -z "${BASH_VERSION}" ]; then
84 exiterror "Not running BASH shell."
85 fi
86
87
88 ############################################################################
89 # #
90 # Trap on emergency exit #
91 # #
92 ############################################################################
93 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
94
95
96 ############################################################################
97 # #
98 # Resetting our nice level #
99 # #
100 ############################################################################
101 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
102 renice $NICE $$ > /dev/null
103 if [ `nice` != "$NICE" ]; then
104 beautify message FAIL
105 exiterror "Failed to set correct nice level"
106 else
107 beautify message DONE
108 fi
109
110
111 ############################################################################
112 # #
113 # Checking if running as root user #
114 # #
115 ############################################################################
116 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
117 if [ `id -u` != 0 ]; then
118 beautify message FAIL
119 exiterror "Not building as root"
120 else
121 beautify message DONE
122 fi
123
124
125 ############################################################################
126 # #
127 # Checking for necessary temporary space #
128 # #
129 ############################################################################
130 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
131 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
132 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
133 if (( 2048000 > $BASE_ASPACE )); then
134 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
135 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
136 beautify message FAIL
137 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
138 fi
139 else
140 beautify message DONE
141 fi
142
143 ############################################################################
144 # #
145 # Building Linux From Scratch system #
146 # #
147 ############################################################################
148 # Set umask
149 umask 022
150
151 # Set LFS Directory
152 LFS=$BASEDIR/build
153
154 # Check /tools symlink
155 if [ -h /tools ]; then
156 rm -f /tools
157 fi
158 if [ ! -a /tools ]; then
159 ln -s $BASEDIR/build/tools /
160 fi
161 if [ ! -h /tools ]; then
162 exiterror "Could not create /tools symbolic link."
163 fi
164
165 # Setup environment
166 set +h
167 LC_ALL=POSIX
168 MAKETUNING="-j6"
169 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
170 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
171
172 # Make some extra directories
173 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
174 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
175 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
176 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
177
178 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
179 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
180
181 # Make all sources and proc available under lfs build
182 mount --bind /dev $BASEDIR/build/dev
183 mount --bind /dev/pts $BASEDIR/build/dev/pts
184 mount --bind /dev/shm $BASEDIR/build/dev/shm
185 mount --bind /proc $BASEDIR/build/proc
186 mount --bind /sys $BASEDIR/build/sys
187 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
188 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
189 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
190 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
191 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
192 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
193 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
194 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
195 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
196
197 # This is a temporary hack!!!
198 if [ ! -f /tools/bin/hostname ]; then
199 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
200 fi
201
202 # Run LFS static binary creation scripts one by one
203 export CCACHE_DIR=$BASEDIR/ccache
204 export CCACHE_HASHDIR=1
205
206 # Remove pre-install list of installed files in case user erase some files before rebuild
207 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
208}
209
210buildtoolchain() {
211 LOGFILE="$BASEDIR/log/_build.toolchain.log"
212 export LOGFILE
213 ORG_PATH=$PATH
214 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
215 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
216 lfsmake1 ccache
217 lfsmake1 binutils PASS=1
218 lfsmake1 gcc PASS=1
219 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
220 lfsmake1 linux-libc-header
221 lfsmake1 glibc
222 lfsmake1 cleanup-toolchain PASS=1
223 lfsmake1 tcl
224 lfsmake1 expect
225 lfsmake1 dejagnu
226 lfsmake1 gcc PASS=2
227 lfsmake1 binutils PASS=2
228 lfsmake1 ncurses
229 lfsmake1 bash
230 lfsmake1 bzip2
231 lfsmake1 coreutils
232 lfsmake1 diffutils
233 lfsmake1 findutils
234 lfsmake1 gawk
235 lfsmake1 gettext
236 lfsmake1 grep
237 lfsmake1 gzip
238 lfsmake1 m4
239 lfsmake1 make
240 lfsmake1 patch
241 lfsmake1 perl
242 lfsmake1 sed
243 lfsmake1 tar
244 lfsmake1 texinfo
245 lfsmake1 util-linux
246 lfsmake1 cleanup-toolchain PASS=2
247 export PATH=$ORG_PATH
248}
249
250buildbase() {
251 LOGFILE="$BASEDIR/log/_build.base.log"
252 export LOGFILE
253 lfsmake2 stage2
254 lfsmake2 linux-libc-header
255 lfsmake2 man-pages
256 lfsmake2 glibc
257 lfsmake2 cleanup-toolchain PASS=3
258 lfsmake2 binutils
259 lfsmake2 gcc
260 lfsmake2 berkeley
261 lfsmake2 coreutils
262 lfsmake2 iana-etc
263 lfsmake2 m4
264 lfsmake2 bison
265 lfsmake2 ncurses
266 lfsmake2 procps
267 lfsmake2 sed
268 lfsmake2 libtool
269 lfsmake2 perl
270 lfsmake2 readline
271 lfsmake2 zlib
272 lfsmake2 autoconf
273 lfsmake2 automake
274 lfsmake2 bash
275 lfsmake2 bzip2
276 lfsmake2 diffutils
277 lfsmake2 e2fsprogs
278 lfsmake2 ed
279 lfsmake2 file
280 lfsmake2 findutils
281 lfsmake2 flex
282 lfsmake2 gawk
283 lfsmake2 gettext
284 lfsmake2 grep
285 lfsmake2 groff
286 lfsmake2 gzip
287 lfsmake2 inetutils
288 lfsmake2 iproute2
289 lfsmake2 kbd
290 lfsmake2 less
291 lfsmake2 libaal
292 lfsmake2 make
293 lfsmake2 man
294 lfsmake2 mktemp
295 lfsmake2 modutils
296 lfsmake2 mtd
297 lfsmake2 net-tools
298 lfsmake2 patch
299 lfsmake2 psmisc
300 lfsmake2 reiser4progs
301 lfsmake2 shadow
302 lfsmake2 sysklogd
303 lfsmake2 sysvinit
304 lfsmake2 tar
305 lfsmake2 texinfo
306 lfsmake2 udev
307 lfsmake2 util-linux
308 lfsmake2 vim
309 lfsmake2 grub
310}
311
312buildipfire() {
313 LOGFILE="$BASEDIR/log/_build.ipfire.log"
314 export LOGFILE
315 ipfiremake configroot
316 ipfiremake backup
317 ipfiremake dhcp
318 ipfiremake dhcpcd
319 ipfiremake libusb
320 ipfiremake libpcap
321 ipfiremake ppp
322 ipfiremake rp-pppoe
323 ipfiremake unzip
324 ipfiremake linux SMP=1
325 ipfiremake ipp2p SMP=1
326 ipfiremake zaptel SMP=1
327 ipfiremake r8169 SMP=1
328 ipfiremake r8168 SMP=1
329 ipfiremake mcs7830 SMP=1
330 ipfiremake atl1 SMP=1
331 ipfiremake linux
332 ipfiremake ipp2p
333 ipfiremake zaptel
334 ipfiremake r8169
335 ipfiremake r8168
336 ipfiremake mcs7830
337 ipfiremake atl1
338 ipfiremake pkg-config
339 ipfiremake linux-atm
340 ipfiremake cpio
341 ipfiremake klibc
342 ipfiremake mkinitcpio
343 ipfiremake udev KLIBC=1
344 ipfiremake expat
345 ipfiremake gdbm
346 ipfiremake gmp
347 ipfiremake pam
348 ipfiremake openssl
349 ipfiremake curl
350 ipfiremake python
351 ipfiremake libnet
352 ipfiremake libidn
353 ipfiremake libjpeg
354 ipfiremake libpng
355 ipfiremake libtiff
356 ipfiremake libart
357 ipfiremake freetype
358 ipfiremake gd
359 ipfiremake popt
360 ipfiremake pcre
361 ipfiremake slang
362 ipfiremake newt
363 ipfiremake libcap
364 ipfiremake pciutils
365 ipfiremake usbutils
366 ipfiremake libxml2
367 ipfiremake libxslt
368 ipfiremake BerkeleyDB
369 ipfiremake mysql
370 ipfiremake cyrus-sasl
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
374 ipfiremake apache2 PASS=C
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake cdrtools
379 ipfiremake dnsmasq
380 ipfiremake dosfstools
381 ipfiremake squashfstools
382 ipfiremake reiserfsprogs
383 ipfiremake xfsprogs
384 ipfiremake sysfsutils
385 ipfiremake fuse
386 ipfiremake ntfs-3g
387 ipfiremake ethtool
388 ipfiremake ez-ipupdate
389 ipfiremake fcron
390 ipfiremake perl-GD
391 ipfiremake GD-Graph
392 ipfiremake GD-TextUtil
393 ipfiremake gnupg
394 ipfiremake hdparm
395 ipfiremake sdparm
396 ipfiremake mtools
397 ipfiremake initscripts
398 ipfiremake whatmask
399 ipfiremake iptables
400 ipfiremake libupnp
401 ipfiremake ipp2p IPT=1
402 ipfiremake linux-igd
403 ipfiremake ipac-ng
404 ipfiremake ipaddr
405 ipfiremake iptstate
406 ipfiremake iputils
407 ipfiremake l7-protocols
408 ipfiremake mISDN
409 ipfiremake capi4k-utils
410 ipfiremake hwdata
411 ipfiremake kudzu
412 ipfiremake logrotate
413 ipfiremake logwatch
414 ipfiremake misc-progs
415 ipfiremake nano
416 ipfiremake nasm
417 ipfiremake URI
418 ipfiremake HTML-Tagset
419 ipfiremake HTML-Parser
420 ipfiremake Compress-Zlib
421 ipfiremake Digest
422 ipfiremake Digest-SHA1
423 ipfiremake Digest-HMAC
424 ipfiremake libwww-perl
425 ipfiremake Net-DNS
426 ipfiremake Net-IPv4Addr
427 ipfiremake Net_SSLeay
428 ipfiremake IO-Stringy
429 ipfiremake Unix-Syslog
430 ipfiremake Mail-Tools
431 ipfiremake MIME-Tools
432 ipfiremake Net-Server
433 ipfiremake Convert-TNEF
434 ipfiremake Convert-UUlib
435 ipfiremake Archive-Tar
436 ipfiremake Archive-Zip
437 ipfiremake Text-Tabs+Wrap
438 ipfiremake Locale-Country
439 ipfiremake XML-Parser
440 ipfiremake glib
441 ipfiremake GeoIP
442 ipfiremake fwhits
443 ipfiremake noip_updater
444 ipfiremake ntp
445 ipfiremake openssh
446 ipfiremake openswan
447 ipfiremake rrdtool
448 ipfiremake setserial
449 ipfiremake setup
450 ipfiremake snort
451 ipfiremake oinkmaster
452 ipfiremake squid
453 ipfiremake squid-graph
454 ipfiremake squidguard
455 ipfiremake calamaris
456 ipfiremake tcpdump
457 ipfiremake traceroute
458 ipfiremake vlan
459 ipfiremake wireless
460 ipfiremake libsafe
461 ipfiremake pakfire
462 ipfiremake java
463 ipfiremake spandsp
464 ipfiremake lzo
465 ipfiremake openvpn
466 ipfiremake pammysql
467 ipfiremake cups
468 ipfiremake ghostscript
469 ipfiremake foomatic
470 ipfiremake hplip
471 ipfiremake samba
472 ipfiremake sudo
473 ipfiremake mc
474 ipfiremake wget
475 ipfiremake bridge-utils
476 ipfiremake screen
477 ipfiremake hddtemp
478 ipfiremake smartmontools
479 ipfiremake htop
480 ipfiremake postfix
481 ipfiremake fetchmail
482 ipfiremake cyrus-imapd
483 ipfiremake openmailadmin
484 ipfiremake clamav
485 ipfiremake spamassassin
486 ipfiremake amavisd
487 ipfiremake alsa
488 ipfiremake mpg123
489 ipfiremake mpfire
490 ipfiremake guardian
491 ipfiremake libid3tag
492 ipfiremake libmad
493 ipfiremake libogg
494 ipfiremake libvorbis
495 ipfiremake lame
496 ipfiremake sox
497 ipfiremake libshout
498 ipfiremake icecast
499 ipfiremake icegenerator
500 ipfiremake mpd
501 ipfiremake mpc
502 ipfiremake xvid
503 ipfiremake libmpeg2
504 ipfiremake videolan
505 ipfiremake libpri
506 ipfiremake asterisk
507 ipfiremake gnump3d
508 ipfiremake libsigc++
509 ipfiremake applejuice
510 ipfiremake ocaml
511 ipfiremake mldonkey
512 ipfiremake libtorrent
513 ipfiremake rtorrent
514 ipfiremake ipfireseeder
515 ipfiremake rsync
516 ipfiremake tcpwrapper
517 ipfiremake portmap
518 ipfiremake nfs
519 ipfiremake nmap
520 ipfiremake mbmon
521 ipfiremake ncftp
522 ipfiremake etherwake
523 ipfiremake bwm-ng
524 ipfiremake tripwire
525 ipfiremake sysstat
526 ipfiremake vsftpd
527 ipfiremake which
528 ipfiremake lsof
529 ipfiremake centerim
530 ipfiremake br2684ctl
531 ipfiremake pcmciautils
532 ipfiremake collectd
533 ipfiremake lcd4linux
534 ipfiremake neon
535 ipfiremake subversion
536 ipfiremake tcptrack
537 ipfiremake teamspeak
538 ipfiremake elinks
539 ipfiremake igmpproxy
540 ipfiremake sdl
541 ipfiremake qemu
542}
543
544buildinstaller() {
545 # Run installer scripts one by one
546 LOGFILE="$BASEDIR/log/_build.installer.log"
547 export LOGFILE
548 ipfiremake syslinux
549 ipfiremake as86
550 ipfiremake mbr
551 ipfiremake memtest
552 installmake linux-libc-header
553 installmake binutils
554 ipfiremake uClibc PASS=1
555 ipfiremake gcc INST=1
556 installmake uClibc PASS=2
557 installmake gcc INST=2
558 installmake uClibc PASS=3
559 installmake busybox
560 installmake udev
561 installmake slang
562 installmake newt
563 installmake gettext
564 installmake kbd
565 installmake popt
566 installmake sysvinit
567 installmake misc-progs
568 installmake libaal
569 installmake reiser4progs
570 installmake reiserfsprogs
571 installmake sysfsutils
572 installmake util-linux
573 installmake pciutils
574 installmake zlib
575 installmake mtd
576 installmake wget
577 installmake hwdata
578 installmake kudzu
579 installmake pcmciautils
580 installmake installer
581 installmake initrd
582}
583
584buildpackages() {
585 LOGFILE="$BASEDIR/log/_build.packages.log"
586 export LOGFILE
587 echo "... see detailed log in _build.*.log files" >> $LOGFILE
588
589 installmake strip
590
591 # Generating list of packages used
592 echo -n "Generating packages list from logs" | tee -a $LOGFILE
593 rm -f $BASEDIR/doc/packages-list
594 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
595 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
596 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
597 fi
598 done
599 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
600 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
601 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
602 rm -f $BASEDIR/doc/packages-list
603 # packages-list.txt is ready to be displayed for wiki page
604 beautify message DONE
605
606 # Create images for install
607 ipfiremake cdrom ED=full
608
609 # Check if there is a loop device for building in virtual environments
610 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
611 ipfiremake usb-stick
612 fi
613 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
614
615 ipfirepackages
616
617 # Cleanup
618 stdumount
619 rm -rf $BASEDIR/build/tmp/*
620
621 # Generating total list of files
622 echo -n "Generating files list from logs" | tee -a $LOGFILE
623 rm -f $BASEDIR/log/FILES
624 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
625 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
626 echo "##" >>$BASEDIR/log/FILES
627 echo "## `basename $i`" >>$BASEDIR/log/FILES
628 echo "##" >>$BASEDIR/log/FILES
629 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
630 fi
631 done
632 beautify message DONE
633
634 cd $PWD
635}
636
637ipfirepackages() {
638 ipfiremake core-updates
639 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
640 if [ -e $BASEDIR/lfs/$i ]; then
641 ipfiredist $i
642 else
643 echo -n $i
644 beautify message SKIP
645 fi
646 done
647 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
648 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
649 rm -rf $BASEDIR/build/install/packages/*
650}
651
652# See what we're supposed to do
653case "$1" in
654build)
655 clear
656 BUILDMACHINE=`uname -m`
657 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
658 #only restore on a clean disk
659 if [ ! -f log/cleanup-toolchain-2-tools ]; then
660 if [ ! -n "$PACKAGE" ]; then
661 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
662 prepareenv
663 buildtoolchain
664 else
665 PACKAGENAME=${PACKAGE%.tar.gz}
666 beautify build_stage "Packaged toolchain compilation"
667 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
668 tar zxf $PACKAGE
669 prepareenv
670 else
671 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
672 fi
673 fi
674 else
675 echo -n "Using installed toolchain" | tee -a $LOGFILE
676 beautify message SKIP
677 prepareenv
678 fi
679
680 beautify build_start
681 beautify build_stage "Building LFS"
682 buildbase
683
684 beautify build_stage "Building IPFire"
685 buildipfire
686
687 # Setzen des IPFire Builds
688 if [ "$SVN_REVISION" ]; then
689 echo "$SVN_REVISION" > $BASEDIR/build/var/ipfire/firebuild
690 else
691 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
692 fi
693
694 beautify build_stage "Building installer"
695 buildinstaller
696
697 beautify build_stage "Building packages"
698 buildpackages
699 beautify build_end
700 ;;
701shell)
702 # enter a shell inside LFS chroot
703 # may be used to changed kernel settings
704 prepareenv
705 entershell
706 ;;
707changelog)
708 echo -n "Loading new Changelog from SVN: "
709 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
710 beautify message DONE
711 ;;
712clean)
713 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
714 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
715 $LOSETUP -d $i 2>/dev/null
716 done
717 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
718 umount $i
719 done
720 stdumount
721 for i in `seq 0 7`; do
722 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
723 umount /dev/loop${i} 2>/dev/null;
724 losetup -d /dev/loop${i} 2>/dev/null;
725 fi;
726 done
727 rm -rf $BASEDIR/build
728 rm -rf $BASEDIR/cdrom
729 rm -rf $BASEDIR/packages
730 rm -rf $BASEDIR/log
731 if [ -h /tools ]; then
732 rm -f /tools
733 fi
734 beautify message DONE
735 ;;
736downloadsrc)
737 if [ ! -d $BASEDIR/cache ]; then
738 mkdir $BASEDIR/cache
739 fi
740 mkdir -p $BASEDIR/log
741 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
742 FINISHED=0
743 cd $BASEDIR/lfs
744 for c in `seq $MAX_RETRIES`; do
745 if (( FINISHED==1 )); then
746 break
747 fi
748 FINISHED=1
749 cd $BASEDIR/lfs
750 for i in *; do
751 if [ -f "$i" -a "$i" != "Config" ]; then
752 echo -ne "Loading $i"
753 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
754 if [ $? -ne 0 ]; then
755 beautify message FAIL
756 FINISHED=0
757 else
758 if [ $c -eq 1 ]; then
759 beautify message DONE
760 fi
761 fi
762 fi
763 done
764 done
765 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
766 ERROR=0
767 for i in *; do
768 if [ -f "$i" -a "$i" != "Config" ]; then
769 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
770 if [ $? -ne 0 ]; then
771 echo -ne "MD5 difference in lfs/$i"
772 beautify message FAIL
773 ERROR=1
774 fi
775 fi
776 done
777 if [ $ERROR -eq 0 ]; then
778 echo -ne "${BOLD}all files md5sum match${NORMAL}"
779 beautify message DONE
780 else
781 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
782 beautify message FAIL
783 fi
784 cd - >/dev/null 2>&1
785 ;;
786toolchain)
787 clear
788 prepareenv
789 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
790 buildtoolchain
791 BUILDMACHINE=`uname -m`
792 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
793 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
794 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
795 build/{bin,etc,usr/bin,usr/local} \
796 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
797 log >> $LOGFILE
798 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
799 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
800 stdumount
801 ;;
802gettoolchain)
803 BUILDMACHINE=`uname -m`
804 # arbitrary name to be updated in case of new toolchain package upload
805 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
806 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
807 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
808 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
809 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
810 cd $BASEDIR/cache/toolchains
811 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
812 if [ $? -ne 0 ]; then
813 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
814 else
815 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
816 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
817 else
818 exiterror "$PACKAGE.md5 did not match, check downloaded package"
819 fi
820 fi
821 else
822 echo "Toolchain is already downloaded. Exiting..."
823 fi
824 ;;
825othersrc)
826 prepareenv
827 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
828 chroot $LFS /tools/bin/env -i HOME=/root \
829 TERM=$TERM PS1='\u:\w\$ ' \
830 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
831 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
832 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
833 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
834 if [ $? -eq "0" ]; then
835 beautify message DONE
836 else
837 beautify message FAIL
838 fi
839 stdumount
840 ;;
841svn)
842 case "$2" in
843 update|up)
844 # clear
845 echo -ne "Loading the latest source files...\n"
846 if [ $3 ]; then
847 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
848 else
849 svn update | tee -a $PWD/log/_build.svn.update.log
850 fi
851 if [ $? -eq "0" ]; then
852 beautify message DONE
853 else
854 beautify message FAIL
855 exit 1
856 fi
857 echo -ne "Writing the svn-info to a file"
858 svn info > $PWD/svn_status
859 if [ $? -eq "0" ]; then
860 beautify message DONE
861 else
862 beautify message FAIL
863 exit 1
864 fi
865 chmod 755 $0
866 exit 0
867 ;;
868 commit|ci)
869 clear
870 if [ -f /usr/bin/mcedit ]; then
871 export EDITOR=/usr/bin/mcedit
872 fi
873 if [ -f /usr/bin/nano ]; then
874 export EDITOR=/usr/bin/nano
875 fi
876 echo -ne "Selecting editor $EDITOR..."
877 beautify message DONE
878 if [ -e /sbin/yast ]; then
879 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
880 $0 changelog
881 fi
882 fi
883 update_langs
884 svn commit
885 $0 svn up
886 if [ -n "$FTP_CACHE_URL" ]; then
887 $0 uploadsrc
888 fi
889 ;;
890 dist)
891 if [ $3 ]; then
892 SVN_REVISION=$3
893 fi
894 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
895 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
896 exit 0
897 fi
898 echo -en "REV $SVN_REVISION: Downloading..."
899 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
900 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
901 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
902 evaluate 1
903
904 echo -en "REV $SVN_REVISION: Compressing files..."
905 if [ -e ipfire-source/trunk/make.sh ]; then
906 chmod 755 ipfire-source/trunk/make.sh
907 fi
908 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
909 evaluate 1
910 echo -en "REV $SVN_REVISION: Cleaning up..."
911 rm ipfire-source/ -r
912 evaluate 1
913 ;;
914 diff|di)
915 update_langs
916 echo -ne "Make a local diff to last svn revision"
917 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
918 evaluate 1
919 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
920 svn status
921 ;;
922 esac
923 ;;
924uploadsrc)
925 PWD=`pwd`
926 cd $BASEDIR/cache/
927 echo -e "Uploading cache to ftp server:"
928 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
929 for i in *; do
930 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
931 grep -q $(basename $i) /tmp/ftplist
932 if [ "$?" -ne "0" ]; then
933 echo -ne "$(basename $i)"
934 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
935 if [ "$?" -ne "0" ]; then
936 beautify message FAIL
937 fi
938 fi
939 done
940 rm -f /tmp/ftplist
941 cd $PWD
942 exit 0
943 ;;
944upload)
945 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
946 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
947 if [ -z $FTP_ISO_PORT ]; then
948 FTP_ISO_PORT=21
949 fi
950 cat <<EOF > .ftp-commands
951mkdir -p $FTP_ISO_PATH$SVN_REVISION
952mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
953quit
954EOF
955 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
956 rm -f .ftp-commands
957
958 case "$2" in
959 iso)
960 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
961
962 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
963 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
964 if [ -e "$i" ]; then
965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
966 if [ "$?" -eq "0" ]; then
967 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
968 else
969 echo "There was an error while uploading the file $i to the ftp server."
970 exit 1
971 fi
972 fi
973 done
974 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
975 if [ "$3" = "--with-sources-cd" ]; then
976 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
977 fi
978 ;;
979 paks)
980 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
981 if [ "$?" -eq "0" ]; then
982 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
983 else
984 echo -e "There was an error while uploading the packages to the ftp server."
985 exit 1
986 fi
987 ;;
988 esac
989 ;;
990batch)
991 if [ "$2" = "--background" ]; then
992 batch_script
993 exit $?
994 fi
995 if [ `screen -ls | grep -q ipfire` ]; then
996 echo "Build is already running, sorry!"
997 exit 1
998 else
999 if [ "$2" = "--rebuild" ]; then
1000 export IPFIRE_REBUILD=1
1001 echo "REBUILD!"
1002 else
1003 export IPFIRE_REBUILD=0
1004 fi
1005 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1006 screen -dmS ipfire $0 batch --background
1007 evaluate 1
1008 exit 0
1009 fi
1010 ;;
1011watch)
1012 watch_screen
1013 ;;
1014pxe)
1015 case "$2" in
1016 start)
1017 start_tftpd
1018 ;;
1019 stop)
1020 stop_tftpd
1021 ;;
1022 reload|restart)
1023 reload_tftpd
1024 ;;
1025 esac
1026 exit 0
1027 ;;
1028lang)
1029 update_langs
1030 ;;
1031"")
1032 clear
1033 svn info
1034 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1035 do
1036 case $name in
1037 "IPFIRE: Downloadsrc")
1038 $0 downloadsrc
1039 ;;
1040 "IPFIRE: Build (silent)")
1041 $0 build-silent
1042 ;;
1043 "IPFIRE: Watch Build")
1044 $0 watch
1045 ;;
1046 "IPFIRE: Batch")
1047 $0 batch
1048 ;;
1049 "IPFIRE: Clean")
1050 $0 clean
1051 ;;
1052 "SVN: Update")
1053 $0 svn update
1054 ;;
1055 "Help")
1056 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1057 cat doc/make.sh-usage
1058 ;;
1059 "LOG: Tail")
1060 tail -f log/_*
1061 ;;
1062 "Exit")
1063 break
1064 ;;
1065 esac
1066 done
1067 ;;
1068config)
1069 make_config
1070 ;;
1071*)
1072 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1073 cat doc/make.sh-usage
1074 ;;
1075esac